section \<open>Exercises for Session 8\<close>

text \<open>
Solve the following exercises by completing undefined definitions
and supplying proofs for all @{command sorry}s below.
\<close>

theory Exercises08
  imports Main
begin

subsection \<open>Exercise 1\<close>

text \<open>
Prove the following lemma only using implicit proof methods.
\<close>
lemma "(A \<inter> B) \<union> (A \<inter> C) \<subseteq> A \<inter> (B \<union> C)"
  sorry

subsection \<open>Exercise 2\<close>

text \<open>
Prove the following lemma (giving an alternative definition of surjectivity
of a function \<open>f\<close> between to sets \<open>A\<close> and \<open>B\<close>) only using the @{method rule} method.
\<close>
lemma "(\<forall>y\<in>B. \<exists>x\<in>A. f x = y) \<longleftrightarrow> B \<subseteq> f ` A"
  sorry

end

